


GENLIB(CMIX-2)      UNIX Programmer's Manual       GENLIB(CMIX-2)



NAME
     cgenlib.a-library of units for Cmix.

DESCRIPTION
     This is a library of functions available for use with user-
     written subroutines in Cmix.  Not all of them are documented
     individually yet, and the user is advised to look at the
     code, stored in /musr/cmix/lib.  There are a few units that
     are still written in fortran.  To use these the name of the
     unit must be followed by an underscore, '_' and all argu-
     ments must be passed by address.  The block routines will
     return a bunch of samples with one subroutine call and are
     thus significantly faster, although trickier to use.  Many
     of these are also available in macro form.  See the manual
     page on macros.  Once an instrument is working properly it
     can be optimized by using block calls and macros.

     The following are currently available:

     allpass.c - allpass filter
     allpole.c - allpole filter for use with lpc
     ampdb.c - returns amplitude from decibels
     ballpole.c - block call allpole filter
     bbuzz.c - block call buzz generator
     boost.c - boost function to compensate for channel position
     boscili.c - block call oscili
     brrand.c - block call rand
     buzz.c - buzz generator
     comb.c - comb filter
     combset.c - initialization call for comb filters
     cpsoct.c - returns cps from octave.pc form
     cpspch.c - returns cps from linear octave form
     dbamp.c - returns decibels from amplitude specification
     delget.c - retrieve value from delay line
     delput.c - put value in delay line
     delset.c - initialize delay line
     dliget.c - get interpolated value from delay line
     evp.c - arbitrary time envelope generator
     evset.c - initialization unit for evp.c
     getsample.c - fetch arbitrary sample block from soundfile
     hcomb.c - precisely tuneable comb filter
     hplset.f - fortran initialization for hpluck
     hcmbst.f - fortran initialization for hcomb
     hpluck.c - precisely tuneable plucked string filter
     octcps.c - returns linear octaves from cps
     octpch.c - returns linear octaves from octave.pc form
     oscil.c - simple oscillator
     oscili.c - interpolating oscillator
     osciln.c - simple oscillator for fm (accepts neg. si)
     oscilni.c - interpolating oscillator for fm
     pchcps.c - returns octave.pc form from cps
     pchoct.c - returns octave.pc form from linear octaves



Printed 9/7/88                                                  1






GENLIB(CMIX-2)      UNIX Programmer's Manual       GENLIB(CMIX-2)



     random.c - returns random number between 0 and 1
     reson.c - two-pole resonator
     reverb.c - reverb unit
     rvbset.c - initialization unit for reverb
     rrand.c - returns random number between -1 and +1
     rsnset.c - initialization unit for reson
     setline.c - load array with arbitrary straight line segments
     table.c - arbitrary time table lookup
     tablei.c - interpolating arbitrary time table lookup
     tableset.c - initialization unit for table and tablei













































Printed 9/7/88                                                  2



