// JOB B94 D0430.PATIENCE REG=384 T=1.0 R=N P=500 N=LPCTEST H=Y PRTY=C
//*FORMAT PR,DEST=VM370,DDNAME=
// EXEC FORTXCLG,PARM.LKED='MAP,LET,LIST,OVLY,SIZE=(150K,150K)'
//FORT.SYSPRINT DD DUMMY
//FORT.SYSIN DD *
      SUBROUTINE $L
      COMMON /LPC/JPOLES,IRECL,NPTS,IFRS
      DIMENSION FRATE(3)
      COMMON /PACK/TAPE(6000),DISK(6000)
      DIMENSION ARRAY(6000)
      DIMENSION PCHVAL(6000)
      COMMON /WARPS/X,PAST(100),C(50),CL,D,CQ,SRD2,NPOLES
      COMMON A(480),SR,NSAMPS,OUT(20),XIN(20),NCHO,NCHI,ZZ(588),F(512,3)
      DIMENSION Q(6),COEF(1000),PCHES(2),RSNSTF(9)
      DATA COEF/1000*0./,ZERO/0./,XINAMP/1./
      DATA INIT/0/,FINIT/0./
      DATA RV1/1048576./,IRV1/1048576/,IRV2/1061/,IRV3/221589/          
      IF(INIT.GT.0) GOTO 1
      CALL BFILL(F(1,1))
C..........FUNCTION SPACE 1 AND 2 ARE NOW TAKEN PERMANENTLY             
C.........ONE TIME INITIALIZATION
      INIT=1
      SRD2=SR/2.
      XMAG=512./SR
      NFWAVE=1
79    LRECL=IRECL
      NPTS=NPOLES+4
      JPOLES=NPOLES
      FRS=IRECL/NPTS
      IFRS=FRS
      FRSP1=FRS+1.
      ISTPT=NPTS+1
1     CONTINUE
C     A(1)=STARTING TIME     A(2)=DURATION  A(3)=FRAME1    A(4)=FRAME2  
C     A(5)=TRANS. FACT       A(6)=D         A(7)=AMP       A(8)=RISET   
C     A(9)=RISEFN            A(10)=DECAYT   A(11)=DECAYFN
C     A(12)----> SPECIFY SPECIFIC FRAME TRANSPOSITIONS IF A(5)=0.       
C     IF(A(6)=10.) D IS CHOSEN ACCORDING TO CURRENT TRANSPOSITION       
C     IN P(12)-->  FRAME1, PCH, FRAME2, PCH, ... FRAMEN PCH FRAMEFINAL  
C     IF PCHES ARE GREATER THAN 15 THEY ARE ASSUMED TO BE IN CPS, OTHER 
C     WISE THEY ARE IN 8VE.PC FORM AND TRANSPOSITION IS BASED ON AVERAGE
C     PITCH OF SPECIFIED STRETCH.
C
C
      CALL OLDFIX
      POINT=512.
      AMP=1.
      SEED=.091381
      BZPHS=0.
      FIRST=ABS(A(3))
      FINAL=A(4)
      IF(A(2).EQ.0.) A(2) = (FINAL-FIRST)/112.
      LENN=6000
      CALL SETFR(A(3),FINAL,RTHRSH,LENN,A(2),ARRAY,DISK)
C.......if first frame is pos, it means voiced and unvoiced at same rate
      IF(A(5).LT.10) GOTO 700
      LOCPCH = A(5)
      CALL PCH(LOCPCH,FREQ,VUV,RMS)
      FREQ2 = CPSPCH(A(7))
      A(5) = PCHOCT(OCTCPS(FREQ2) - OCTCPS(FREQ))
      PRINT*,LOCPCH,FREQ,VUV,RMS,FREQ2,A(5)
700   TRANSP=OCTPCH(A(5))
      XFRMS=(FINAL-FIRST)+1.
      XFRPT=0.
      RANAMP=AMP*RANFAC
      DO 2 M=1,100
2     PAST(M)=0.
C        FIND FIRST FRAME AND GET FIRST RECORD OF COEFFICIENTS          
      NREC=((FIRST-1.)/FRS)+1.
      NNREC=NREC
      CALL GETCO(NREC,COEF(ISTPT))
      FPOINT=AINT(AMOD(FIRST-1.,FRS)+2.05)
      CALL SETNOT(A(1),A(2))
      CALL TBISET(A(2),LENN,FRATE)
      XSMPM1=NSAMPS-1
      NFRISE=A(9)
      NFDEC=A(11)
      CALL EVSET(A(2),A(8),NFRISE,A(10),NFDEC,Q)
C........ARBITRARILY SET SI TO START OFF
C      CALL SETIN(ZERO)
      SI=150.*512./SR
C..........STARTING SAMPLING RATE
C.............BRANCH HERE TO SET TRANSP IF NECESSARY
      JCOUNT=1
      IF(A(5).NE.0.) GOTO 1001
C      CALL TRANS(A(12),PCHVAL,JFRMS)
      CALL DIST(A(12),FIRST,FINAL,PCHVAL)
      CALL TABSET(A(2),JFRMS,PCHES)
      QFL=0
      OFPNT=FPOINT
1001  DO 1000 JSAM=1,NSAMPS
      POINT=POINT+SI
      IF(POINT.LT.512.) GOTO 600
      POINT=POINT-512.
      FFP=TABLEI(JSAM,ARRAY,FRATE)
      FPOINT=AMOD(FFP-1.,FRS)+2.
      IF(FPOINT.LT.OFPNT) GOTO 292
C..........IF MOD HAD FOLDED FPOINT UNDER, BRANCH TO GETNEW REC ALSO    
      IF(FPOINT.LT.FRSP1) GOTO 200
      FPOINT=FPOINT-FRS
292   NREC=((FFP)/FRS)+1.
      IF(NREC.EQ.NNREC) GOTO 200
      NNREC=NREC
      DO 201 M=1,NPTS
      COEF(M)=COEF(M+LRECL)
201   CONTINUE
      CALL GETCO(NREC,COEF(ISTPT))
      IF(FPOINT.LT.1.) FPOINT=1.
200   CONTINUE
      OFPNT=FPOINT
      NSECT=FPOINT
      NBASE=NPTS*(NSECT-1)+1
      NBASE2=NBASE+NPTS
      AINTRP=FPOINT-AINT(FPOINT)
      AMPMLT=(1.-AINTRP)*COEF(NBASE)+AINTRP*COEF(NBASE2)
      IFLAG=0.
      IF(COEF(NBASE+2).GT.THRESH) IFLAG=1
710   CALL INTERS(COEF(NBASE+4),COEF(NBASE2+4),AINTRP,NPOLES,C(1))      
      ENVAL=AMPMLT*EVP(JSAM,Q)
C        GET PROPER PITCH
      IF(A(5).EQ.0.) GOTO 5
      CPS=OCTCPS((1.-AINTRP)*COEF(NBASE+3)+AINTRP*COEF(NBASE2+3))       
      CPS=CPSOCT(CPS+TRANSP)
      GOTO 6
5     NP=FFP-FIRST+1
      NPP1=NP+1
      CPSA=PCHVAL(NP)
      CPSB=PCHVAL(NPP1)
      CPS=AINTRP*CPSB+(1.-AINTRP)*CPSA
6     CONTINUE
      D=A(6)
      IF(D.LE.1.) GOTO 50
      XCPS=COEF(NBASE+3)*(1.-AINTRP)+COEF(NBASE2+3)*AINTRP              
      CALL SHIFT(XCPS,CPS,D)
50    CONTINUE
              CL=1.
C           SET CL JUST IN CASE WARPST IS NOT CALLED
      IF(D.NE.0.) CALL WARPST
      HN=AINT(SRD2/CPS)
      CALL RSZSET(CPS,BW*CPS,1.,RSNSTF)
      IF(IFLAG.EQ.0) SI=CPS*XMAG
C...........LEAVE SI ALONE IF UNVOICED FRAME
600   CONTINUE
      IF(IFLAG.GT.0) GOTO 11
C10    X=BUZZ(AMP,SI,HN,NFWAVE,BZPHS)
10         J$ = BZPHS
           K$ = MOD(J$+1,1024)
           H2N$ = 2.* HN
           H2N$P1 = H2N$+1.
           Q$ = AINT(( BZPHS -AINT( BZPHS ))*H2N$P1)/H2N$P1             
           D$ = F(J$+1, NFWAVE )
           E$ = F(K$+1, NFWAVE )
           D$ = D$+(E$-D$)*Q$
           IF (D$.NE.0.) GOTO 20000
           X = AMP
           GO TO 30000
20000      K$ = MOD(IFIX(H2N$P1* BZPHS ),1024)
           X = AMP *(F(K$+1, NFWAVE )/D$-1.)/H2N$
30000      BZPHS = AMOD( BZPHS + SI ,1024.)

C11    X=RAND(RANAMP,SEED)
11         N$= SEED *RV1
           SEED =FLOAT(MOD(IRV2*N$+IRV3,IRV1))/RV1
           X = RANAMP *(1.-2.* SEED )
           X = RESONZ(X,RSNSTF)
12    CONTINUE
         IF(D.EQ.0.) GOTO 506
      CALL WRPPOL
      GOTO 507
C-----      OLD FILTER
506   J=JCOUNT
      DO 505 NFINT=1,NPOLES
      X=X+C(NFINT)*PAST(J)
505   J=J+1
      K=JCOUNT
      PAST(K)=X
      PAST(K+NPOLES)=X
      JCOUNT=MOD(JCOUNT,NPOLES)+1
507   OUT(1)=X*ENVAL*CL
      CALL PUTOUT
1000  CONTINUE
      CALL ENDNOT
      RETURN
      ENTRY $R
C........TO SET THE RESON
      BW = A(1)
      SCL = 1
      CALL RSZSET(200.,BW*200.,0.,RSNSTF)
      RETURN
      ENTRY $F
      IF(A(1).NE.0.) RANFAC=A(1)
      IF(A(2).NE.0.) THRESH=A(2)
      IF(A(3).NE.0.) NPOLES=A(3)
      IF(A(4).NE.0.) IRECL=A(4)
      IF(A(5).NE.0.) XINAMP=A(5)
C...........SET AMPLITUDE FOR ADDED INPUT NOISE
      RTHRSH=A(6)
      IF(RTHRSH.EQ.0.) RTHRSH=THRESH
      FINIT=1.
      WRITE(6,100) RANFAC,THRESH,NPOLES,IRECL,XINAMP,RTHRSH             
 100   FORMAT( ' RANFAC THRESH,NPOLES,IRECL,XINAMP FIXED AT ',6G10.4)   
      RETURN
      END
//LKED.SYSLMOD DD SPACE=(CYL,(1,1,1),,CONTIG),UNIT=SYSDA
//LKED.SYSPRINT DD DUMMY
//LKED.PROG DD DSN=U.LANSKY.LPCPLAY,DISP=SHR
//         DD DSN=U.LANSKY.LOAD,DISP=SHR
//LKED.SYSIN DD DSN=U.LANSKY.NEWMIX,DISP=SHR
//GO.FT98F001 DD DSN=D0430S,DISP=SHR
//GO.FT97F001 DD DSN=D0430C,DISP=SHR,DCB=(BUFNO=1)
//GO.FT96F001 DD DSN=U.LANSKY.TAPELIB,DISP=SHR,DCB=(BUFNO=1)
//GO.FT10F001 DD DSN=U.LANSKY.JANE1,DISP=SHR
//GO.FT60F001 DD DSN=U.LANSKY.JANE2,DISP=SHR
//GO.SYSIN DD *
FUNCTION SPACES 1 AND 2 ARE TAKEN BY SINE FOR BUZZ GENERATOR
FSTUFF .1 .02 32 504 0 1
GEN 3 7 0 512 1 ; STRAIGHT LINE
DATASET 10
PUNCH 1 1 1 1
